local ReturnBuffTracker = LibStub("AceAddon-3.0"):GetAddon("ReturnBuffTracker")

ReturnBuffTracker.Buffs = {
    [01] = {
        name = "Alive",
        shortName = "Alive",
        func = "CheckAlive",
        color = {r = 0.3, g = 1, b = 0.3},
        buffOptionsGroup = "General"
    },
    [02] = {
        name = "Healer Mana",
        shortName = "Healer",
        optionText = "Healer Mana",
        func = "CheckMana",
        color = {r = 0.4, g = 0.6, b = 1},
        classes = {"PRIEST", "PALADIN", "DRUID", "SHAMAN"},
        buffOptionsGroup = "General"
    },
    [03] = {
        name = "DPS Mana",
        shortName = "DPS",
        optionText = "DPS Mana",
        func = "CheckMana",
        color = {r = 0.2, g = 0.2, b = 1},
        classes = {"HUNTER", "WARLOCK", "MAGE"},
        buffOptionsGroup = "General"
    },
    [04] = {
        name = "In Combat",
        shortName = "In Combat",
        color = {r = 1, g = 1, b = 1},
        buffOptionsGroup = "General",
        func = "CheckInCombat"
    },
    [05] = {
        name = "Seelenstein-Auferstehung",
        shortName = "Seelensteine",
        color = {r = 0.58, g = 0.51, b = 0.79},
        buffOptionsGroup = "Player",
        func = "CheckSoulstones"
    },
    [06] = {
        name = "Arkane Intelligenz",
        shortName = "Intelligenz",
        color = {r = 0.41, g = 0.8, b = 0.94},
        buffNames = {"Arkane Intelligenz", "Arkane Brillanz"},
        classes = {"HUNTER", "WARLOCK", "PRIEST", "PALADIN", "DRUID", "MAGE", "SHAMAN"},
        buffOptionsGroup = "Player"
    },
    [07] = {
        name = "Mal der Wildnis",
        shortName = "MdW",
        color = {r = 1.0, g = 0.49, b = 0.04},
        buffNames = {"Mal der Wildnis", "Gabe der Wildnis"},
        buffOptionsGroup = "Player"
    },
    [08] = {
        name = "Machtwort: Seelenstärke",
        shortName = "Ausdauer",
        color = {r = 1.0, g = 1.0, b = 1.0},
        buffNames = {"Machtwort: Seelenstärke", "Gebet der Seelenstärke"},
        buffOptionsGroup = "Player"
    },
    [09] = {
        name = "Göttlicher Wille",
        shortName = "Göttlicher Wille",
        color = {r = 1.0, g = 1.0, b = 1.0},
        buffNames = {"Göttlicher Wille", "Göttliche Segnung"},
        classes = {"PRIEST", "PALADIN", "DRUID", "MAGE", "SHAMAN"},
        buffOptionsGroup = "Player"
    },
    [10] = {
        name = "Schattenschutz",
        shortName = "Schattenschutz",
        color = {r = 0.6, g = 0.6, b = 0.6},
        buffNames = {"Schattenschutz", "Gebet des Schattenschutzes"},
        buffOptionsGroup = "Player"
    },
    [11] = {
        name = "Schlachtruf der Drachentöter",
        shortName = "Ony",
        color = {r = 0, g = 0, b = 0},
        buffNames = {"Schlachtruf der Drachentöter"},
        buffIDs = {22888},
        buffOptionsGroup = "World"
    },
    [12] = {
        name = "Segen des Kriegshäuptlings",
        shortName = "Rend",
        color = {r = 0, g = 0, b = 0},
        buffNames = {"Segen des Kriegshäuptlings"},
        buffIDs = {16609},
        buffOptionsGroup = "World"
    },
    [13] = {
        name = "Liedblumenserenade",
        shortName = "Liedblume",
        color = {r = 0, g = 0, b = 0},
        buffNames = {"Liedblumenserenade"},
        buffIDs = {15366},
        buffOptionsGroup = "World"
    },
    [14] = {
        name = "Fengus' Wildheit",
        shortName = "DM AP",
        color = {r = 0, g = 1, b = 1},
        buffNames = {"Fengus' Wildheit"},
        buffIDs = {22817},
        classes = {"WARRIOR", "ROGUE"},
        buffOptionsGroup = "World"
    },
    [15] = {
        name = "Slip'kik's Grips",
        shortName = "DM Crit",
        classes = {"WARLOCK", "PRIEST", "PALADIN", "DRUID", "MAGE", "SHAMAN"},
        color = {r = 0, g = 1, b = 1},
        buffNames = {"Slip'kik's Grips"},
        buffIDs = {22820},
        buffOptionsGroup = "World"
    },
    [16] = {
        name = "Mol'Dars Mut",
        shortName = "DM Stamina",
        color = {r = 0, g = 1, b = 1},
        buffNames = {"Mol'Dars Mut"},
        buffIDs = {22818},
        buffOptionsGroup = "World"
    },
    [17] = {
        name = "Arkanschutztrank",
        shortName = "Arkanschutztrank",
        optionText = "Großer Arkanschutztrank",
        color = {r = 1, g = 0, b = 0},
        buffOptionsGroup = "Consumable"
    },
    [18] = {
        name = "Feuerschutztrank",
        shortName = "Feuerschutztrank",
        optionText = "Großer Feuerschutztrank",
        color = {r = 1, g = 0, b = 0},
        buffOptionsGroup = "Consumable"
    },
    [19] = {
        name = "Frostschutztrank",
        shortName = "Frostschutztrank",
        optionText = "Großer Frostschutztrank",
        color = {r = 1, g = 0, b = 0},
        buffOptionsGroup = "Consumable"
    },
    [20] = {
        name = "Naturschutztrank",
        shortName = "Naturschutztrank",
        optionText = "Großer Naturschutztrank",
        color = {r = 1, g = 0, b = 0},
        buffOptionsGroup = "Consumable"
    },
    [21] = {
        name = "Schattenschutztrank",
        shortName = "Schattenschutztrank",
        optionText = "Großer Schattenschutztrank",
        color = {r = 1, g = 0, b = 0},
        buffOptionsGroup = "Consumable"
    },
    [22] = {
        name = "Großes Arkanelixier",
        shortName = "Arkanelixier",
        color = {r = 0.58, g = 0.51, b = 0.79},
        buffIDs = {17539},
        buffOptionsGroup = "Consumable",
        classes = {"WARLOCK", "MAGE"}
    },
    [23] = {
        name = "Elixir der Schattenmacht",
        shortName = "Schattenmacht",
        color = {r = 0.58, g = 0.51, b = 0.79},
        buffIDs = {11474},
        buffOptionsGroup = "Consumable",
        classes = {"WARLOCK"}
    },
    [24] = {
        name = "Elixier des Mungos",
        shortName = "Mungo",
        color = {r = 0.58, g = 0.51, b = 0.79},
        buffIDs = {17538},
        buffOptionsGroup = "Consumable",
        classes = {"WARRIOR", "ROGUE", "HUNTER"}
    },
    [25] = {
        name = "Kraft des Juju",
        shortName = "Stärke Juju",
        color = {r = 0.58, g = 0.51, b = 0.79},
        buffIDs = {16323},
        buffOptionsGroup = "Consumable",
        classes = {"WARRIOR", "ROGUE"}
    },
    [26] = {
        name = "Macht des Juju",
        shortName = "AP Juju",
        color = {r = 0.58, g = 0.51, b = 0.79},
        buffIDs = {16329},
        buffOptionsGroup = "Consumable",
        classes = {"WARRIOR", "ROGUE", "HUNTER"}
    },
    [27] = {
        name = "Feuerwasser der Winterfelle",
        shortName = "Feuerwasser",
        color = {r = 0.58, g = 0.51, b = 0.79},
        buffIDs = {17038},
        buffOptionsGroup = "Consumable",
        classes = {"WARRIOR", "ROGUE"}
    },
    [28] = {
        name = "Elixir der Seelenstärke",
        shortName = "Seelenstärke",
        color = {r = 0.58, g = 0.51, b = 0.79},
        buffIDs = {3593},
        buffOptionsGroup = "Consumable",
        classes = {"WARRIOR", "ROGUE"}
    }
}

function ReturnBuffTracker:CheckAlive()
    tooltip = {}
    tooltip[1] = "Dead: "
    tooltip[2] = "no one."
    local j = 2

    local aliveNumber = 0
    local totalNumber = 0
    for i = 1, 40 do
        name = GetRaidRosterInfo(i)
        if name then
            totalNumber = totalNumber + 1
            if not UnitIsDeadOrGhost("raid" .. i) then
                aliveNumber = aliveNumber + 1
            else
                tooltip[j] = name
                j = j + 1
            end
        end
    end
    return aliveNumber, totalNumber, tooltip
end

function ReturnBuffTracker:CheckMana(buff)
    local mana = 0
    local totalMana = 0
    for i = 1, 40 do
        _, _, _, _, _, class = GetRaidRosterInfo(i)
        if class and ReturnBuffTracker:Contains(buff.classes, class) then
            local unitPower = UnitPower("raid" .. i, 0)
            local unitPowerMax = UnitPowerMax("raid" .. i, 0)
            if unitPower and unitPowerMax and unitPowerMax > 0 then
                mana = mana + (unitPower / unitPowerMax)
                totalMana = totalMana + 1
            end
        end
    end

    return mana, totalMana
end

function ReturnBuffTracker:CheckInCombat(buff)
    local inCombat = 0
    local total = 0
    local players = {}

    for i = 1, 40 do
        name, _, group = GetRaidRosterInfo(i)
        if name and not UnitIsDead("raid" .. i) then
            total = total + 1
            if UnitAffectingCombat("raid" .. i) then
                inCombat = inCombat + 1
            else
                players[name] = {name = name, group = group}
            end
        end
    end

    tooltip = {}
    tooltip[1] = "Not in Combat: "
    tooltip[2] = "no one."

    groups = {}
    for k, player in pairs(players) do
        if not groups[player.group] then
            groups[player.group] = {text = "Group " .. player.group .. ":"}
        end
        groups[player.group].text = groups[player.group].text .. " " .. player.name
    end

    local i = 2
    for _, group in ipairs(groups) do
        tooltip[i] = group.text
        i = i + 1
    end

    return inCombat, total, tooltip
end

function ReturnBuffTracker:CheckSoulstones(buff)
    tooltip = {}
    tooltip[1] = "Soulstones: "
    tooltip[2] = "none."
    local j = 2

    for i = 1, 40 do
        name = GetRaidRosterInfo(i)
        if name and ReturnBuffTracker:CheckUnitBuff("raid" .. i, buff) then
            tooltip[j] = name
            j = j + 1
        end
    end

    return 1, 1, tooltip
end

function ReturnBuffTracker:CheckBuff(buff)
    local buffs = 0
    local totalBuffs = 0
    local players = {}

    for i = 1, 40 do
        name, _, group, _, _, class = GetRaidRosterInfo(i)
        if class and ReturnBuffTracker:Contains(buff.classes, class) then
            totalBuffs = totalBuffs + 1
            if ReturnBuffTracker:CheckUnitBuff("raid" .. i, buff) then
                buffs = buffs + 1
            else
                players[name] = {name = name, group = group, class = class}
            end
        end
    end

    tooltip = {}
    tooltip[1] = "Missing " .. buff.name .. ": "
    tooltip[2] = "no one."

    groups = {}

    if buff.missingMode == "class" then
        for k, player in pairs(players) do
            if not groups[player.class] then
                groups[player.class] = {
                    text = ReturnBuffTracker.Constants.ClassNames[player.class] .. ":"
                }
            end
            groups[player.class].text = groups[player.class].text .. " " .. player.name
        end
    else
        for k, player in pairs(players) do
            if not groups[player.group] then
                groups[player.group] = {
                    count = 0,
                    text = "Group " .. player.group .. ":"
                }
            end
            groups[player.group].text = groups[player.group].text .. " " .. player.name
        end
    end

    local i = 2
    for _, group in pairs(groups) do
        tooltip[i] = group.text
        i = i + 1
    end

    return buffs, totalBuffs, tooltip
end

function ReturnBuffTracker:CheckUnitBuff(unit, buff)
    for i = 1, 40 do
        local b, _, _, _, _, _, _, _, _, spellId = UnitBuff(unit, i)
        if buff.buffIDs then
            if ReturnBuffTracker:Contains(buff.buffIDs, spellId) then
                return true
            end
        else
            if (buff.buffNames and ReturnBuffTracker:Contains(buff.buffNames, b)) or buff.name == b then
                return true
            end
        end
    end
    return false
end
